{ lib, canix, ... }:
with lib; {

  # Resource metadata
  # ========================================================================

  description = ''
    A Wireguard-based IP backbone tunnel, used to
    provide routable address to service hosts, to support redundant paths
    and to enable bandwidth constraints. When expanded, this resource's spec
    will describe point-to-point tunnel definitions for each of its downlink
    clients, along with the necessary cryptographic key material and some
    metadata used for bandwidth limits and OSPF-based dynamic pathing.  
  '';
  nodes = with canix; [ MACHINE ];

  # Template options
  # ========================================================================

  template.options = {

    baseName = mkOption {
      description = ''
        The name of this tunnel, used to derive the interface name.
      '';
      default = config.name;
      type = types.singleLineStr;
    };

    addresses = mkOption {
      description = ''
        The addresses to assign to the tunnel's interface.
      '';
      type = types.listOf types.singleLineStr;
    };
    port = mkOption {
      description = ''
        The port that the tunnel server should listen to.
      '';
      type = types.port;
    };
  };

  # Instance options
  # ==========================================================================

  instance.options = {

    privateKey = canix.mkSecretOption {
      description = ''
        The private key used by this tunnel server.
      '';
      internal = true;
      # FIXME: remove when this is properly defined by the configuration
      default = {
        path = "XXX";
        script = "XXX";
      };
      defaultText = "A private key generated by `wg genkey`.";
    };

    clients = mkOption {
      description = ''
        The client resources that use this tunnel as an uplink.
      '';
      internal = true;
      type = types.listOf (canix.submodule {
        options = {

          name = mkOption {
            description = ''
              The name of the tunnel to the client resource.
            '';
            type = types.singleLineStr;
            defaultText = "The qualified name of the peer's parent node.";
          };

          addresses = mkOption {
            description = ''
              The addresses assigned to the tunnel's remote peer.
            '';
            type = types.listOf types.singleLineStr;
            defaultText = "Directly sourced from the peer's configuration.";
          };

          cost = mkOption {
            description = ''
              The cost assigned to this link by the tunnel's remote peer.
            '';
            type = types.numbers.nonnegative;
            defaultText = "Directly sourced from the peer's configuration.";
          };

          limits = mkOption {
            description = ''
              The rate limiting to apply to this link (named from the point
               of view of the client resource).
            '';
            type = canix.limitsOptionType;
          };

          publicKey = canix.mkSecretOption {
            description = ''
              The public key of the tunnel's remote peer.
            '';
            defaultText = "Derived from the peer's generated private key.";
          };

          preSharedKey = canix.mkSecretOption {
            description = ''
              The pre-shared key for this tunnel.
            '';
            defaultText = "Copied from the peer's generated pre-shared key.";
          };
        };
      });
      # FIXME: remove when this is properly defined by the configuration
      default = [ ];
      defaultText = "#TODO";
    };
  };

  # Instance config
  # ==========================================================================

  instance.config = { };

  # System modules
  # ==========================================================================

  instance.system.nixos = ./nixos.nix;

}
